#ifndef OAT_MASTER_HPP
#define OAT_MASTER_HPP


#include"oat_imagemodule.hpp"


namespace oat{


class
Master final: public Widget
{
public:
  using KeyboardCallback = void  (*)(const Keyboard&      kbd, void*  userdata);
  using     DropCallback = void  (*)(const std::string&  path, void*  userdata);

private:
  DirectColorImageModule  module;

  Widget*  current;

  Widget*  mousegrabber;

  KeyboardCallback   kbd_callback;
  DropCallback      drop_callback;

  void*   kbd_userdata;
  void*  drop_userdata;

public:
   Master();
  ~Master() override;


  void  change_key_receiver(Widget*  w);

  void  change_mousegrabber(Widget*  w);

  void  process(Mouse&   mouse);
  void  process(const Keyboard&  kbd);
  void  process(const std::string&  path);

  void  set_keyboard_callback(KeyboardCallback  cb, void*  userdata=nullptr);
  void  set_drop_callback(DropCallback  cb, void*  userdata=nullptr);

  bool  update();

  Color&  get_pixel(int  x, int  y) const;

  const DirectColorImageModule&  get_module() const;

};


}




#endif




